#include "tools.h"
#include <util/delay.h>

//
// Recht genaue Pausen-Routine fr den ms Bereich
//
void pause_ms(unsigned int  ms)
{
	unsigned int zaehler;
	
	while (ms)
	{
		zaehler = F_CPU / 5000;
		
		while (zaehler)
		{
			asm volatile ("nop");
			zaehler--;
		}
		ms--;
	}
}


//
// Debug mit ANSI Steuerung fuer die Position!
// pos 0,0 Loescht den Bildschirm !
//

void DebugXY(unsigned char x, unsigned char y,  char *Ptr)
{
   char Buffer[10];

   if ((x == 0) && (y == 0))
   {
      Buffer[0] = 0x1b;
      Buffer[1] = '[';
      Buffer[2] = '2';
      Buffer[3] = 'J';
      Buffer[4] = 0x00;
      Debug(&Buffer[0]);

      Buffer[0] = 0x1b;
      Buffer[1] = '[';
      Buffer[2] = '1';
      Buffer[3] = ';';
      Buffer[4] = '1';
      Buffer[5] = 'H';
      Buffer[6] = 0x00;
      Debug(&Buffer[0]);
   }
   else
   {
      Buffer[0] = 0x1b;
      Buffer[1] = '[';
      Buffer[2] = (y/10)+48;
      Buffer[3] = (y%10)+48;
      Buffer[4] = ';';
      Buffer[5] = (x/10)+48;
      Buffer[6] = (x%10)+48;
      Buffer[7] = 'f';
      Buffer[8] = 0x00;
      Debug(&Buffer[0]);
      Debug(Ptr);
   }
}


/* 	Beliebigen Port wird als Ausgang konfiguriert und dann per Software UART 
	verwendet. In dem Beispiel wird der normale txd Anschlu genutzt aufgrund 
	der Hardwarebeschaltung auf meiner Platine 
	nutzt die _delay_us der AVRLib */

void Debug(char *Ptr)
{
   #define DEBUG_DDR 	DDRD
   #define DEBUG_PORT	PORTD
   #define DEBUG_BIT	PD1

//Wartezeit in us 
   #define MINDELAY		104   	// fuer 9600 bps
// #define MINDELAY		26 		// fuer 38400 bps
// #define MINDELAY 	417		// fuer 2400 bps ACHTUNG nicht mit _delay_us machtbar!!
								// zumindest nicht als einzelner aufruf!
								
   unsigned char i;

   DEBUG_DDR |= _BV(DEBUG_BIT);					// Port als Ausgang
   DEBUG_PORT |= _BV(DEBUG_BIT);				// Port mit HIGH vorbelegen

   while(*Ptr != 0)
   {
      DEBUG_PORT &= ~_BV(DEBUG_BIT);
      _delay_us(MINDELAY);				       // Start Bit

      for (i=0;i<8;i++)                      // Alle 8 Bits
      {
         if (*Ptr & (0x01<<i))
         {
            DEBUG_PORT |= _BV(DEBUG_BIT);
            _delay_us(MINDELAY);
         }
         else
         {
            DEBUG_PORT &= ~_BV(DEBUG_BIT);
			_delay_us(MINDELAY);         }
      }
      DEBUG_PORT |= _BV(DEBUG_BIT);				// Stop Bit
	  _delay_us(MINDELAY);
      Ptr++;
   }
}
